function newmatrix = insertelement(oldmatrix,row,column,value,grow)

% This function simply inserts a new element of value into oldmatrix at the
% position given by row,column. It shifts all elements in column after the
% inserted data to higher rows. It returns the new matrix in newmatrix.

% If grow is set, the matrix grows by one row, otherwise the highest
% element in the column is lost.

newmatrix = oldmatrix; % start with copy
m = size(oldmatrix,1);
% shift data to higher rows to make room for insertion
if grow == 1
    newmatrix((row+1):m+1,column) = newmatrix(row:m,column);
else
    newmatrix((row+1):m,column) = newmatrix(row:m-1,column);
end;

% add inserted value
newmatrix(row,column) = value;